using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using AutoMapper;
using MileageTraker.Web.Attributes;
using MileageTraker.Web.DAL;
using MileageTraker.Web.Models;
using MileageTraker.Web.Utility;

namespace MileageTraker.Web.ViewModels.CreateLog
{
	public class CreateLogViewModel : IValidatableObject
	{
		[Required(ErrorMessage = "Required")]
		[Remote("Exists", "Vehicle", ErrorMessage = "ID not found")]
		[StringLength(6, MinimumLength = 4, ErrorMessage = "Must be a 4 digit number")]
		[Display(Name = "Vehicle ID")]
		[InputSize("mini")]
		[RegularExpression(@"\d+", ErrorMessage = "Must be all numbers")]
		public string VehicleId { get; set; }

		[Required(ErrorMessage = "Required")]
		[Range(1, 500000, ErrorMessage = "Between 1 and 500k")]
		[Display(Name = "End Odometer")]
		[Units("Miles")]
		[InputSize("small")]
		[RegularExpression(@"\d+", ErrorMessage = "Must be all numbers")]
		public string EndOdometer { get; set; }

		[Required(ErrorMessage = "Required")]
		[Display(Name = "Type")]
		[NoEditLabel]
		public MileageLogTypeWrapper LogType { get; set; }

		[Required(ErrorMessage = "Required")]
		[Display(Name = "Destination City")]
		[InputSize("medium")]
		[StringLength(64, MinimumLength = 3, ErrorMessage = "Minimum 3 characters")]
		public string CityName { get; set; }

		[RegularExpression(@"\d+\.\d{3}", ErrorMessage = "Enter all 3 decimal places")]
		[Display(Name = "Gas Purchased")]
		[DisplayFormat(DataFormatString = "{0:0.000}", ApplyFormatInEditMode = true)]
		[Units("Gallons")]
		[FormatHint("n.nnnn")]
		[InputSize("mini")]
		public string GasPurchased { get; set; }

		[Required(ErrorMessage = "Required")]
		[DataType(DataType.Date)]
		[DisplayFormat(DataFormatString = @"{0:MM/dd/yyyy}", ApplyFormatInEditMode = true)]
		[DenyFutureDate(ErrorMessage = "Future date")]
		[DenyPreviousMonthDate(ErrorMessage = "Previous Month")]
		[FormatHint("mm/dd/yyyy")]
		[InputSize("small")]
		public DateTime Date { get; set; }

		static CreateLogViewModel()
		{
			Mapper.CreateMap<string, int>().ConvertUsing(Convert.ToInt32);
			Mapper.CreateMap<string, double>().ConvertUsing(Convert.ToDouble);
			Mapper.CreateMap<string, DateTime>().ConvertUsing(new DateTimeTypeConverter());
			Mapper.CreateMap<CreateLogViewModel, Models.Log>();
		}

		public CreateLogViewModel()
		{
			// view will crash if this isn't instantiated
			LogType = new MileageLogTypeWrapper();
		}

		public Models.Log GetLog()
		{
			var log = new Models.Log();
			Mapper.Map(this, log);
			return log;
		}

		public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
		{
			if (LogType == MileageLogType.GasPurchase
				&& (string.IsNullOrEmpty(GasPurchased) || double.Parse(GasPurchased) == 0))
				yield return new ValidationResult("Enter amount of gas purchased", new [] {"GasPurchased"});

			if (LogType.Value == 0)
				yield return new ValidationResult("Required", new[] { "LogType" });

			ValidationResult result = null;
			try
			{
				using (var dataService = new DataService())
				{
					dataService.ValidateOdometerChronology(VehicleId, int.Parse(EndOdometer), Date);
				}
			}
			catch (Exception ex)
			{
				result = new ValidationResult(ex.Message, new [] {"EndOdometer"});
			}
			if (result != null)
				yield return result;
		}
	}
}